public inbox for isar-users@googlegroups.com
 help / color / mirror / Atom feed
From: Alexander Smirnov <asmirnov@ilbers.de>
To: isar-users@googlegroups.com
Cc: Alexander Smirnov <asmirnov@ilbers.de>
Subject: [PATCH v5 07/12] linux: Add ARM cross-compilation support
Date: Mon, 30 Jul 2018 19:39:32 +0000	[thread overview]
Message-ID: <20180730193937.32694-8-asmirnov@ilbers.de> (raw)
In-Reply-To: <20180730193937.32694-1-asmirnov@ilbers.de>

Add possibility to cross-compile ARM target.

Signed-off-by: Alexander Smirnov <asmirnov@ilbers.de>
---
 meta/recipes-kernel/linux/files/build-kernel.sh | 24 +++++++++++++++++++++---
 meta/recipes-kernel/linux/linux-custom.inc      |  2 +-
 2 files changed, 22 insertions(+), 4 deletions(-)

diff --git a/meta/recipes-kernel/linux/files/build-kernel.sh b/meta/recipes-kernel/linux/files/build-kernel.sh
index 1ec094e..cc137a8 100644
--- a/meta/recipes-kernel/linux/files/build-kernel.sh
+++ b/meta/recipes-kernel/linux/files/build-kernel.sh
@@ -9,6 +9,22 @@
 
 set -e
 
+host_arch=$(dpkg --print-architecture)
+target_arch=$2
+
+if [ "$host_arch" != "$target_arch" ]; then
+    case $target_arch in
+    armhf)
+        export ARCH=arm
+        export CROSS_COMPILE="arm-linux-gnueabihf-"
+        ;;
+    *)
+        echo "error: unsupported architecture ($target_arch)"
+        exit 1
+        ;;
+    esac
+fi
+
 REPACK_DIR="$1/../repack"
 REPACK_LINUX_IMAGE_DIR="${REPACK_DIR}/linux-image"
 REPACK_LINUX_HEADERS_DIR="${REPACK_DIR}/linux-headers"
@@ -29,7 +45,7 @@ if [ "${KV}" != "${PV}" ]; then
 fi
 
 rm -f .version
-make -j $(($(nproc) * 2)) deb-pkg
+KBUILD_DEBARCH=$target_arch make -j $(($(nproc) * 2)) deb-pkg
 
 rm -rf ${REPACK_DIR}
 mkdir -p ${REPACK_DIR}
@@ -49,7 +65,8 @@ dpkg-gencontrol -crepack/debian/control \
 	-DPackage="linux-image-${KERNEL_NAME}" \
 	-DSection=kernel \
 	-DPriority=required \
-	-DDepends="${KERNEL_DEBIAN_DEPENDS}"
+	-DDepends="${KERNEL_DEBIAN_DEPENDS}" \
+	-DArchitecture=$target_arch
 
 # Add Debian-like link installation to postinst
 touch ${REPACK_LINUX_IMAGE_DIR}/lib/modules/${PV}/.fresh-install
@@ -82,7 +99,8 @@ dpkg-gencontrol -crepack/debian/control \
 	-Vkernel:debarch="${KERNEL_NAME}" \
 	-DPackage="linux-headers-${KERNEL_NAME}" \
 	-DSection=kernel \
-	-DDepends="${KERNEL_HEADERS_DEBIAN_DEPENDS}"
+	-DDepends="${KERNEL_HEADERS_DEBIAN_DEPENDS}" \
+	-DArchitecture=$target_arch
 
 dpkg-deb -b ${REPACK_LINUX_IMAGE_DIR} \
 	linux-image-${KERNEL_NAME}_${PV}-1_${KERNEL_NAME}.deb
diff --git a/meta/recipes-kernel/linux/linux-custom.inc b/meta/recipes-kernel/linux/linux-custom.inc
index 1176b25..d5fc5a6 100644
--- a/meta/recipes-kernel/linux/linux-custom.inc
+++ b/meta/recipes-kernel/linux/linux-custom.inc
@@ -43,5 +43,5 @@ dpkg_runbuild() {
 	export KERNEL_DEBIAN_DEPENDS="${KERNEL_DEBIAN_DEPENDS}"
 	export KERNEL_HEADERS_DEBIAN_DEPENDS="${KERNEL_HEADERS_DEBIAN_DEPENDS}"
 
-	sudo -E chroot ${BUILDCHROOT_DIR} /build-kernel.sh ${PP}/${PPS}
+	sudo -E chroot ${BUILDCHROOT_DIR} /build-kernel.sh ${PP}/${PPS} ${DISTRO_ARCH}
 }
-- 
2.11.0


  parent reply	other threads:[~2018-07-30 19:40 UTC|newest]

Thread overview: 21+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2018-07-30 19:39 [PATCH v5 00/12] Cross-compilation Alexander Smirnov
2018-07-30 19:39 ` [PATCH v5 01/12] isar-bootstrap: Update routine to determine host arch Alexander Smirnov
2018-07-30 19:39 ` [PATCH v5 02/12] buildchroot: Split generic part Alexander Smirnov
2018-07-30 19:39 ` [PATCH v5 03/12] buildchroot: Add host buildchroot Alexander Smirnov
2018-07-30 19:39 ` [PATCH v5 04/12] isar-bootstrap-helper: Add target architecture for dpkg Alexander Smirnov
2018-07-30 19:39 ` [PATCH v5 05/12] build.sh: Add additional parameter Alexander Smirnov
2018-08-01 14:51   ` Alexander Smirnov
2018-08-02  4:05     ` Maxim Yu. Osipov
2018-08-02  7:56     ` Henning Schild
2018-08-02 11:05       ` Alexander Smirnov
2018-08-02 17:05         ` Henning Schild
2018-08-02 18:16           ` Alexander Smirnov
2018-07-30 19:39 ` [PATCH v5 06/12] cross-compilation: Introduce variable switch Alexander Smirnov
2018-07-30 19:39 ` Alexander Smirnov [this message]
2018-07-30 19:39 ` [PATCH v5 08/12] isar: Add ARM64 cross-compilation support Alexander Smirnov
2018-07-30 19:39 ` [PATCH v5 09/12] linux-module: Export ARCH and CROSS_COMPILE Alexander Smirnov
2018-07-30 19:39 ` [PATCH v5 10/12] linux: Drop gcc from dependencies Alexander Smirnov
2018-07-30 19:39 ` [PATCH v5 11/12] doc: Provide some notes about cross-compilation Alexander Smirnov
2018-07-30 19:39 ` [PATCH v5 12/12] scripts/ci_build.sh: Add cross-compilation test Alexander Smirnov
2018-08-02 19:00 ` [PATCH v5 00/12] Cross-compilation Alexander Smirnov
2018-08-06  7:57 ` Maxim Yu. Osipov

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20180730193937.32694-8-asmirnov@ilbers.de \
    --to=asmirnov@ilbers.de \
    --cc=isar-users@googlegroups.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox